
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JavaEE 并发：一、FOR UPDATE 实战，监测并解决。 / iVAN</title>

    <meta name="description" content="JavaEE 并发：一、FOR UPDATE 实战，监测并解决。 一.前言 针对并发,老生常谈了.目前一个通用的做法有两种:锁机制:1.悲观锁:2.乐观锁. 但是这篇我主要用于记录我这次处理的经历,另外希望能看的大神,大牛,技师者,学长,兄长,大哥们能在评论中发表自己的看法和解决技巧等.   二.故事是这样的 一个表,暂且叫 wallet,其中3个字段是 金额.初始值为0,如下图所示:   然后我们写了一个极为简单的Controller,并写了下面的Service代码: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 @Overri">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JavaEE 并发：一、FOR UPDATE 实战，监测并解决。</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>一、前言</h2>
<p>针对并发，老生常谈了。目前一个通用的做法有两种：锁机制：1.悲观锁；2.乐观锁。</p>
<p>但是这篇我主要用于记录我这次处理的经历，另外希望能看的大神，大牛，技师者，学长，兄长，大哥们能在评论中发表自己的看法和解决技巧等。</p>
<p> </p>
<h2>二、故事是这样的</h2>
<p>一个表，暂且叫 wallet,其中3个字段是 金额。初始值为0,如下图所示：<br /><a href="http://www.bysocket.com/wp-content/uploads/2015/03/image2.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9pbWFnZV90aHVtYjIucG5n.jpg"></a></p>
<p> </p>
<p>然后我们写了一个极为简单的Controller，并写了下面的Service代码：</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15
</td>
<td>
<p><code>@Override</code></p>
<p><code>    </code><code>public void testLock(int lockId)</code></p>
<p><code>    </code><code>{</code></p>
<p><code>        </code><code>Wallet wallet = walletMapper.selectByPrimaryKey(4);</code></p>
<p><code>        </code> </p>
<p><code>        </code><code>BigDecimal one = new BigDecimal(1.00);</code></p>
<p><code>        </code><code>BigDecimal two = new BigDecimal(2.00);</code></p>
<p><code>        </code><code>BigDecimal three = new BigDecimal(3.00);</code></p>
<p><code>        </code> </p>
<p><code>        </code><code>wallet.setWalletAmount(wallet.getWalletAmount().add(one));</code></p>
<p><code>        </code><code>wallet.setWalletAvailableAmount(wallet.getWalletAvailableAmount().subtract(two));</code></p>
<p><code>        </code><code>wallet.setOldAmount(wallet.getOldAmount().add(three));      </code></p>
<p><code>        </code> </p>
<p><code>        </code><code>walletMapper.updateByPrimaryKeySelective(wallet);</code></p>
<p><code>    </code><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>就简单的通过主键读取到一个对象，注意这个对象是没加锁的。也就是说，所对应的SQL如下：</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4
</td>
<td>
<p><code>SELECT </code></p>
<p><code>    </code><code>&lt;</code><code>include</code> <code>refid</code><code>=</code><code>"Base_Column_List"</code> <code>/&gt;</code></p>
<p><code>    </code><code>FROM wallet</code></p>
<p><code>    </code><code>WHERE wallet_id = #{walletId,jdbcType=INTEGER}</code></p>
</td>
</tr>
</tbody>
</table>
<p>我这边是MyBiatis，大家应该看得懂的。然后一个增加1 一个减少2 一个增加 3。</p>
<p> </p>
<h2>三、测试是这样</h2>
<p>我用了Web应用压力测试工具：<strong>Boom</strong>。<a href="https://github.com/rakyll/boom" rel="external nofollow noreferrer">https://github.com/rakyll/boom</a> Go编写的HTTP(S)负载生成器，ApacheBench（AB）的替代工具。Boom是一个微型程序，能够对Web应用程序进行负载测试。它类似于 Apache Bench ，但在不同的平台上有更好的可用性，安装使用也比较简单。</p>
<p>简单使用方式如下：</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18
</td>
<td>
<p><code>boom -n 1000 -c 200 <a href="http://www.baidu.com/" rel="external nofollow noreferrer">http://www.baidu.com</a></code></p>
<p> </p>
<p><code>Options:</code></p>
<p><code>  </code><code>-n  Number of requests to run.</code></p>
<p><code>  </code><code>-c  Number of requests to run concurrently. Total number of requests cannot</code></p>
<p><code>      </code><code>be smaller than the concurency level.</code></p>
<p><code>  </code><code>-q  Rate limit, in seconds (QPS).</code></p>
<p><code>  </code><code>-o  Output type. If none provided, a summary is printed.</code></p>
<p><code>      </code><code>"csv" is the only supported alternative. Dumps the response</code></p>
<p><code>      </code><code>metrics in comma-seperated values format.</code></p>
<p><code> </code> </p>
<p><code>  </code><code>-m  HTTP method, one of GET, POST, PUT, DELETE, HEAD, OPTIONS.</code></p>
<p><code>  </code><code>-h  Custom HTTP headers, name1:value1;name2:value2.</code></p>
<p><code>  </code><code>-d  HTTP request body.</code></p>
<p><code>  </code><code>-T  Content-type, defaults to "text/html".</code></p>
<p><code>  </code><code>-a  Basic authentication, username:password.</code></p>
<p><code> </code> </p>
<p><code>  </code><code>-allow-insecure Allow bad/expired TLS/SSL certificates.</code></p>
</td>
</tr>
</tbody>
</table>
<p>所以我就如图进行压力测试，可见这个小工具还挺美的，这里我<strong>连接数1000，并发数100</strong>：<br /><a href="http://www.bysocket.com/wp-content/uploads/2015/03/image3.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9pbWFnZV90aHVtYjMucG5n.jpg"></a><br />
可见后台程序报错了。什么错误呢？</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>Caused by: com.mysql.jdbc.exceptions.jdbc4.MySQLTransactionRollbackException: Deadlock found when trying to get lock; try restarting transaction</code></p>
</td>
</tr>
</tbody>
</table>
<p>原来并发导致update<strong>死表</strong>了。数据库的数据不用看了肯定是错误的。</p>
<p> </p>
<h2>四、FOR UPDATE的使用</h2>
<p>先补一下其知识：利用select * for update 可以锁表/锁行。自然锁表的压力远大于锁行。所以我们采用<strong>锁行</strong>。什么时候锁表呢？</p>
<p>假设有个表单products ，里面有id跟name二个栏位，id是主键。<br />
例1: (明确指定主键，并且有此笔资料，row lock)<br />
SELECT * FROM wallet WHERE id=’3′ FOR UPDATE;<br />
例2: (明确指定主键，若查无此笔资料，无lock)<br />
SELECT * FROM wallet WHERE id=’-1′ FOR UPDATE;<br />
例2: (无主键，table lock)<br />
SELECT * FROM wallet WHERE name=’Mouse’ FOR UPDATE;<br />
例3: (主键不明确，table lock)<br />
SELECT * FROM wallet WHERE id&lt;&gt;’3′ FOR UPDATE;<br />
例4: (主键不明确，table lock)<br />
SELECT * FROM wallet WHERE id LIKE ‘3’ FOR UPDATE;</p>
<p> </p>
<p>因此我们更新了下Service层的Mapper方法：</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15
</td>
<td>
<p><code>@Override</code></p>
<p><code>    </code><code>public void testLock(int lockId)</code></p>
<p><code>    </code><code>{</code></p>
<p><code>        </code><code>Wallet wallet = walletMapper.selectForUpdate(4);</code></p>
<p><code>        </code> </p>
<p><code>        </code><code>BigDecimal one = new BigDecimal(1.00);</code></p>
<p><code>        </code><code>BigDecimal two = new BigDecimal(2.00);</code></p>
<p><code>        </code><code>BigDecimal three = new BigDecimal(3.00);</code></p>
<p><code>        </code> </p>
<p><code>        </code><code>wallet.setWalletAmount(wallet.getWalletAmount().add(one));</code></p>
<p><code>        </code><code>wallet.setWalletAvailableAmount(wallet.getWalletAvailableAmount().subtract(two));</code></p>
<p><code>        </code><code>wallet.setOldAmount(wallet.getOldAmount().add(three));      </code></p>
<p><code>        </code> </p>
<p><code>        </code><code>walletMapper.updateByPrimaryKeySelective(wallet);</code></p>
<p><code>    </code><code>}</code></p>
</td>
</tr>
</tbody>
</table>
<p>所对应的SQL如下：</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7
</td>
<td>
<p><code>&lt;</code><code>select</code> <code>id</code><code>=</code><code>"selectForUpdate"</code> <code>resultMap</code><code>=</code><code>"BaseResultMap"</code> <code>parameterType</code><code>=</code><code>"java.lang.Integer"</code> <code>&gt;</code></p>
<p><code>  </code><code>SELECT </code></p>
<p><code>  </code><code>&lt;</code><code>include</code> <code>refid</code><code>=</code><code>"Base_Column_List"</code> <code>/&gt;</code></p>
<p><code>  </code><code>FROM wallet</code></p>
<p><code>  </code><code>WHERE wallet_id = #{walletId,jdbcType=INTEGER}</code></p>
<p><code>  </code><code>FOR UPDATE</code></p>
<p><code>&lt;/</code><code>select</code><code>&gt;</code></p>
</td>
</tr>
</tbody>
</table>
<p>自然大家可以看到，我这边加了锁，是通过主键锁行。</p>
<p> </p>
<p>按着上面的测试<strong>连接数1000，并发数100</strong>，控制台没报错。</p>
<p><a href="http://www.bysocket.com/wp-content/uploads/2015/03/image4.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9pbWFnZV90aHVtYjQucG5n.jpg"></a></p>
<p>数据库结果也是很不错。</p>
<p><a href="http://www.bysocket.com/wp-content/uploads/2015/03/image5.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9pbWFnZV90aHVtYjUucG5n.jpg"></a></p>
<p> </p>
<h2>五、加大压力</h2>
<p>按着上面的测试<strong>连接数5000，并发数350</strong>，控制台还是没报错。</p>
<p><a href="http://www.bysocket.com/wp-content/uploads/2015/03/image6.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9pbWFnZV90aHVtYjYucG5n.jpg"></a></p>
<p>数据库结果却是很出错了！！！<br /><a href="http://www.bysocket.com/wp-content/uploads/2015/03/image7.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9pbWFnZV90aHVtYjcucG5n.jpg"></a></p>
<p>少update了很多值。为什么呢？</p>
<p> </p>
<h2>六、jvisualvm 小工具检测，发现Tomcat线程连接数默认不够</h2>
<p>然后我用jvisualvm 小工具检测。多测了几次，发现<strong>连接数5000，并发数350</strong>，并发数上升。有一个图的值始终不变。如图：</p>
<p><a href="http://www.bysocket.com/wp-content/uploads/2015/03/QQ20150322124739.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9RUTIwMTUwMzIyMTI0NzM5X3RodW1iLnBuZw==.jpg"></a></p>
<p>发现图中 tomcat的守护线程一直在200左右。后来我去找了下tomcat的server.xml发现了，使用了默认，大概就是200左右。</p>
<p> </p>
<p>所以就配置了一下，大致配置方法有两种如下：</p>
<p>第1种方式：配置Connector<br />
maxThreads：tomcat可用于请求处理的最大线程数<br />
minSpareThreads：tomcat初始线程数，即最小空闲线程数<br />
maxSpareThreads：tomcat最大空闲线程数，超过的会被关闭<br />
acceptCount：当所有可以使用的处理请求的线程数都被使用时，可以放到处理队列中的请求数，超过这个数的请求将不予处理</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>&lt;</code><code>Connectorport</code><code>=</code><code>"8080"</code><code>maxHttpHeaderSize</code><code>=</code><code>"8192"</code><code>maxThreads</code><code>=</code><code>"150"</code><code>minSpareThreads</code><code>=</code><code>"25"</code><code>maxSpareThreads</code><code>=</code><code>"75"</code><code>enableLookups</code><code>=</code><code>"false"</code><code>redirectPort</code><code>=</code><code>"8443"</code><code>acceptCount</code><code>=</code><code>"100"</code><code>connectionTimeout</code><code>=</code><code>"20000"</code><code>disableUploadTimeout</code><code>=</code><code>"true"</code><code>/&gt;</code></p>
</td>
</tr>
</tbody>
</table>
<p> </p>
<p>第2种方式：配置Executor和Connector</p>
<p>name：线程池的名字<br />
class：线程池的类名<br />
namePrefix：线程池中线程的命名前缀<br />
maxThreads：线程池的最大线程数<br />
minSpareThreads：线程池的最小空闲线程数<br />
maxIdleTime：超过最小空闲线程数时，多的线程会等待这个时间长度，然后关闭<br />
threadPriority：线程优先级</p>
<p><a href="http://www.bysocket.com/?p=191#" rel="external nofollow noreferrer">?</a></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>&lt;</code><code>Executorname</code><code>=</code><code>"tomcatThreadPool"</code><code>namePrefix</code><code>=</code><code>"req-exec-"</code><code>maxThreads</code><code>=</code><code>"1000"</code><code>minSpareThreads</code><code>=</code><code>"50"</code><code>maxIdleTime</code><code>=</code><code>"60000"</code><code>/&gt;</code></p>
<p> </p>
<p><code>&lt;</code><code>Connectorport</code><code>=</code><code>"8080"</code><code>protocol</code><code>=</code><code>"HTTP/1.1"</code><code>executor</code><code>=</code><code>"tomcatThreadPool"</code><code>/&gt;</code></p>
</td>
</tr>
</tbody>
</table>
<p> </p>
<p>maxThreads：线程池的最大线程数，直接配置1000，然后用连接数10000，并发数800测试。轻松见图：</p>
<p><a href="http://www.bysocket.com/wp-content/uploads/2015/03/UFRJFLLO6F1LWQ6EQJ8P8.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9VRlJKRkxMTzZGMUxXUTZFUUo4UDhfdGh1bWIucG5n.jpg"></a></p>
<h2><a href="http://www.bysocket.com/wp-content/uploads/2015/03/image8.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmJ5c29ja2V0LmNvbS93cC1jb250ZW50L3VwbG9hZHMvMjAxNS8wMy9pbWFnZV90aHVtYjgucG5n.jpg"></a></h2>
<h2>七、总结</h2>
<p>感谢帮助我的人。希望有大牛在此讨论相关。小生感激不尽。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 10:04:04</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JavaEE 并发：一、FOR UPDATE 实战，监测并解决。的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXqLvWz.html" rel="bookmark">JavaWeb 并发：FOR UPDATE 实战，监测并解决。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 针对并发,老生常谈了.目前一个通用的做法有两种:锁机制:1.悲观锁:2.乐观锁. 但是这篇我主要用于记录我这次处理的经历,另外希望能看的大神,大牛,技师者,学长,兄长,大哥们能在评论中发表自己的看法和解决技巧等.   二.故事是这样的 一个表,暂且叫 wallet,其中3个字段是 金额.初始值为0,如下图所示:   然后我们写了一个极为简单的Controller,并写了下面的Service代码: 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 @Override			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7kKQKz.html" rel="bookmark">Win8&period;1系统Update无法启动如何解决？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Win8.1系统Update无法启动如何解决?          是否需要重装系统吗?不,这时可以使用Win8.1安装镜像+应急命令来修复,例如最经典的sfc /scannow命令. 解决方法: 1.首先下载一个Win8.1系统镜像,刻录DVD安装光盘或者制作U盘启动工具. 2.接着插入DVD安装光盘或者U盘,打开电脑电源,设置BIOS启动项,使用安装光盘/U盘启动. 注意:当出现上图提示后,快速敲击任何按键 3.当出现Win8.1安装界面时,使用组合键Shift + F10打开命令窗口. 4.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJZ2D2z.html" rel="bookmark">win8&period;1 update安装失败80070020解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  遇到win8.1 update安装失败80070020怎么办?下文将告诉大家win8.1update安装失败80070020解决方法,很多网友表示无法安装win8.1 update,该如何解决呢?希望下文的方法对大家有所帮助. Win8.1 Update已正式发布,但众多用户遇到了下载问题,目前无法从Windows Update下载.微软社区论坛的Win8.1用户表示,Windows 8.1 Update无法安装,错误代码80070020,没有向用户提供其他具体信息. 微软尚未发布补丁解决用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmR1ab.html" rel="bookmark">多线程-求 有关 高并发 数据区 读取更新 数据 的解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 求 有关 高并发 数据区 读取更新 数据 的解决办法 问题:高并发 数据库取数据,每次取到一条数据后更新这条数据的状态为已取用过. 环境:3台服务器跑应用 处理请求,多线程数据库取数据 有点类似 12306的买票,查找过资料 有看到 1W人 同时抢一张票的问题. 现在考虑的问题是,如果票是足够多的,如何解决高并发取数据冲突的问题,如果用加锁的方式,会出现大量请求都取一条数据,导致 等待时间太长. 有没有 好的方案,可以避免同时请求到同一条数据. 解决方案 可以用大数据分布式云计算物联网			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjmjKZz.html" rel="bookmark">Win7开机屏幕显示&OpenCurlyDoubleQuote;正在配置Windows Update&comma;请勿关机&rdquo;如何解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  方法一: 1.开始--控制面板--查看方式:类别,点击打开系统和安全; 2.选择Windows update--更改设置--从不检测更新,把推荐更新和谁可以安装更新项目下的勾勾掉,确定. 方法二: 1.开始,搜索运行gpedit.msc,打开组策略; 2.在弹出的选项卡中选择用户配置--管理模板--Windows组件--Windows update--选择删除使用所有Windows update功能的访问权限. 3.双击删除使用所有Windows update功能的访问权限,弹出选项卡,设置			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlB8vOz.html" rel="bookmark">IIS处理并发请求时出现的问题及解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文http://www.cnblogs.com/hgamezoom/p/3082538.html 一个ASP.NET项目在部署到生产环境时,当用户并发量达到200左右时,IIS出现了明显的请求排队现象,发送的请求都进入等待,无法及时响 应,系统基本处于不可用状态.因经验不足,花了很多时间精力解决这个问题,本文记录了我查找问题的过程和最后解决方案,供大家参考.   软硬件环境: IBM刀片服务器,Intel至强处理器,4物理核,16个逻辑核心,内存32G Windows Server2008 E			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvvZANM.html" rel="bookmark">&lbrack;20170215&rsqb;ORA-00088与DG Gap监测与解决4</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[20170215]ORA-00088与Data Guard Gap Detection and Resolution4.txt --前一阵子遇到的测试,链接如下: http://blog.itpub.net/267265/viewspace-2133106/ http://blog.itpub.net/267265/viewspace-2133107/ http://blog.itpub.net/267265/viewspace-2133250/ --//根据链接的讨论,zergduan给出的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyWAv8z.html" rel="bookmark">winxp&lbrack;sp2&rsqb;下Apache无法正常使用实战得出的解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近准备搞几个PHP的网站,于是需要在自己的电脑里装个PHP的服务器,已经很久没碰PHP,apache,mysql这些东西了所以就偷个懒直接下在个套装软件叫appserv,它可以一次性的在你的机器中安装php,mysql,apache,zend,phpmyadmin软件,非常的方便,而且有多种组合方式,详细可以去他的网站去了解.因为很早以前就用过这个软件,都是象软件一样安装好就可以用了的,可这次确遇到了个大麻烦.我先是下载了AppServ 2.5.3 这个版本.我的系统是win xp sp2 版			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkVL7b.html" rel="bookmark">《Java 7并发编程实战手册》第四章线程执行器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				感谢人民邮电大学授权并发网发布此书样章,新书购买传送门=&gt;当当网 本章将介绍下列内容: 创建线程执行器 创建固定大小的线程执行器 在执行器中执行任务并返回结果 运行多个任务并处理第一个结果 运行多个任务并处理所有结果 在执行器中延时执行任务 在执行器中周期性执行任务 在执行器中取消任务 在执行器中控制任务的完成 在执行器中分离任务的启动与结果的处理 处理在执行器中被拒绝的任务 4.1 简介 通常,使用Java来开发一个简单的并发应用程序时,会创建一些 Runnable 对象,然后创建对应的 Th			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBmkz7.html" rel="bookmark" class="title">腾讯10亿布局搜索 后起之秀示威百度</a>
					<div>
						谷歌中国的衰退,成就了百度的如日中天.但这并不意味着百度能安然就寝,因为来自国内的后起之秀正悄悄地对它发起冲击. 在马云声称让李彦宏睡不着觉时,来自深圳的马化腾以及百度的邻居张朝阳也从未放缓自己在搜索 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvnWrM.html" rel="bookmark" class="title">Properties读取文件缓存数据</a>
					<div>
						private static Properties cache = new Properties(); static{ try { cache.load(ConfigInfo.class.getCla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6w6Wp.html" rel="bookmark" class="title">访问程序包 DBMS</a>
					<div>
						application|程序|访问 系统环境:客户端:WINXP+ORACLE9.2.0.1客户端服务端:WIN2003+ORACLE9.2.0.5 错误描述:非sys用户连接全部报错 c:/&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Og3z.html" rel="bookmark" class="title">PHP ADOdb、PDO、ODBC连接Access数据库代码教程</a>
					<div>
						在PHP网站开发中,PHP与Mysql是最好的组合,但是当你想将其他平台的网站移植到PHP平台时,必然遇到移植性的问题,如ASP+ACCESS平台如何移植?首当其冲便是PHP连接Access数据库问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4BB9M.html" rel="bookmark" class="title">用ASP编写网络传呼机&lpar;转&rpar;</a>
					<div>
						网络 用ASP编写网络传呼机  出处:http://wodeail.on.net.cn/article/list.asp?id=322 正文: 各位喜欢上网冲浪的朋友一定都去过网易的虚拟社区吧,里面的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4EoJb.html" rel="bookmark" class="title">SEO接单如何给客户推荐与报价合理的关键词</a>
					<div>
						前段时间写过两篇关于seo接单的文章,&lt;SEO接单应先建立朋友关系 哄好客户是关键&gt;和&lt;SEO接单之如何让客户心理平衡感觉物有所值&gt;,今天小女子继续为大家写一篇关于seo接单, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62EyXM.html" rel="bookmark" class="title">Weblogic8配置Oracle数据库连接池</a>
					<div>
						1.配置连接池 通过http://localhost:7001/console进入管理控制台 在左侧菜单中依次进入mydomain(自定义的域名称)-服务-JDBC-连接缓冲池 点击&quot;配置新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7883M.html" rel="bookmark" class="title">iOS网络编程入门：iCloud键值数据存储编程实例</a>
					<div>
						iCloud键值数据存储设计 iCloud键值数据存储编程实例,画面中有两个开关控件,左图是设备1点击&quot;设置iCloud数据&quot;按钮,将控件状态保存到iCloud服务器.右图是设备2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKvXZM.html" rel="bookmark" class="title">PS制作刻在石头或树木上的文字效果刻字教程</a>
					<div>
						教程教大家制作逼真的刻在石头或树木上的文字效.刚刚自己琢磨了一下做的,在网上找到的刻字教程普遍比这个做法复杂. 做这种字效都不难,先在需要的材质上打上字,主要用图层样式设置一下,逼真的效果就出来了.这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrN68p.html" rel="bookmark" class="title">在Word2010文档中设置艺术字发光效果</a>
					<div>
						第1步,打开Word2010文档窗口,单击准备设置发光效果的艺术字,使其处于编辑状态. 第2步,在&quot;绘图工具/格式&quot;功能区中,单击&quot;形状样式&quot;分组中的&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badnPqz.html" rel="bookmark" class="title">借助Disk SpeedUP工具 整理磁盘为本本提速</a>
					<div>
						  只需借助一个小工具就可以帮我们每天使用的笔记本磁盘进行高效整理,大大的提升磁盘速度,本本不再因为每天频繁的操作而速度越来越慢,这个工具的名字叫做-Disk SpeedUP.对于本本动辄就500GB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72Bwdp.html" rel="bookmark" class="title">双频wifi是什么意思？</a>
					<div>
						  双频Wifi是指设备同时支持2.4GHz/5GHz 双频段无线信号,可支持包含 802.11a/b/g/n 完整无线网络,其属于第五代Wi-Fi传输技术(5G Wi-Fi),通常我们日常接触到的路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3k2BM.html" rel="bookmark" class="title">arraylist&amp;amp&semi;amp&semi;lt&semi;T&amp;amp&semi;amp&semi;gt&semi; 怎么定义啊</a>
					<div>
						问题描述 arraylist&lt;T&gt; 怎么定义啊 arraylist 怎么定义啊 arraylist 怎么定义啊 arraylist 怎么定义啊 arraylist 怎么定义啊 解决方案 A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJyWkp.html" rel="bookmark" class="title">下一代网络：大道至&OpenCurlyDoubleQuote;简&rdquo;</a>
					<div>
						网络应该是 &quot;赋能&quot;的工具,而不是相反.&quot;复杂&quot;正在成为我们迈向下一代互联网最大的障碍. &quot;简网络&quot;让企业管理者不必再关心那些让人眼花缭乱的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1rBNb.html" rel="bookmark" class="title">git上上传项目</a>
					<div>
						1.注册账户以及创建仓库      要想使用github第一步当然是注册github账号了.之后就可以创建仓库了(免费用户只能建公共仓库),Create a New Repository,填好名称后C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaB59M.html" rel="bookmark" class="title">&lbrack;Java&rsqb;深入理解Java内存模型（一）基础</a>
					<div>
						在并发编程中,我们需要处理两个关键问题:线程之间如何通信及线程之间如何同步(这里的线程是指并发执行的活动实体).通信是指线程之间以何种机制来交换信息.在命令式编程中,线程之间的通信机制有两种:共享内存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKv3dM.html" rel="bookmark" class="title">ThinkPHP控制器里javascript代码不能执行的解决方法&lowbar;php实例</a>
					<div>
						本文实例讲述了ThinkPHP控制器里javascript代码不能执行的解决方法.分享给大家供大家参考.具体方法如下: 这里实例分析一下thinkphp在控制器里的网页特效代码不能执行解决方法,就拿& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAj1oM.html" rel="bookmark" class="title">JS下载文件&vert;无刷新下载文件示例代码&lowbar;javascript技巧</a>
					<div>
						后台代码Handler.ashx 复制代码 代码如下: &lt;%@ WebHandler Language=&quot;C#&quot; Class=&quot;Handler&quot; %&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7LPkz.html" rel="bookmark" class="title">请问程序图标组的分类怎么实现？自动对任务栏上的程序图标分类</a>
					<div>
						问题描述 请问程序图标组的分类怎么实现?自动对任务栏上的程序图标分类 请问程序图标组的分类怎么实现?自动对任务栏上的程序图标分类,比如应用.游戏.工具等,装入对应的菜单,用VB怎么做? 解决方案 用d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP4LDp.html" rel="bookmark" class="title">搜索引擎靠什么驱动</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 搜索引擎将互联网海量信息整合,通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRB5vz.html" rel="bookmark" class="title">mybatis 模糊查询  like a  and  like b怎么写？</a>
					<div>
						问题描述 MySQL数据库上,mybatis 如果模糊查询,两个条件怎么写?请指点一下. 一个条件的模糊查询,测试通过:WHERE STORE_SALE.PRODUCT_NAME LIKE '%'|| ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq27xb.html" rel="bookmark" class="title">【Android】Android中WIFI开发总结（二）</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://smallwoniu.blog.51cto.com/3911954/1338618 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkw6X1p.html" rel="bookmark" class="title">qt5-QT使用 mysql时出现问题，求大神看下</a>
					<div>
						问题描述 QT使用 mysql时出现问题,求大神看下 我的系统:win7 64bit QT版本:QT5.4 vs2013的编译器 MySQL5.6安装正常 我是初学者,想试验一下mysql的使用,用m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRLVmb.html" rel="bookmark" class="title">苹果正在呈下滑趋势</a>
					<div>
						对于苹果,我想大部分都是其粉丝,铁杆粉丝也不少,我也像大部分粉丝一样,期待着她的每一个新产品和创新.当乔布斯去世以后,我毫无根据的在那认为苹果会走下坡路,不过当时股价表现和盈利似乎跟我的预言唱反调.知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAADAJM.html" rel="bookmark" class="title">jsp-关于网站维护&OpenCurlyDoubleQuote;百度统计&rdquo;，有没有大神可以指导下，或者推荐资料！</a>
					<div>
						问题描述 关于网站维护&quot;百度统计&quot;,有没有大神可以指导下,或者推荐资料! 公司现在做后期网站维护了,让我学习下&quot;百度统计&quot;的知识,但是大量的JSP对于我这种小白 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBGkWM.html" rel="bookmark" class="title">MYSQL查看和新增表分区</a>
					<div>
						MYSQL查看和新增表分区 1.查看表分区 SELECT  partition_name part,   partition_expression expr,   partition_descript ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ArjNz.html" rel="bookmark" class="title">投资客：两个创始人的不同选择</a>
					<div>
						上海有家做新药开发的企业,公司创始人在美国某实验室,做了十六年药物的基础研究,他最大的梦想就是将自己十多年的研究成果变成药物.于是回国创业,五年时间取得惊人的成绩.在美国,如果要做出这样的成果,不仅资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xNXgb.html" rel="bookmark" class="title">阿里云APP上线&OpenCurlyDoubleQuote;备案刷脸核验&rdquo;功能&nbsp;&nbsp;网站备案时间大幅缩短</a>
					<div>
						建过网站的人都知道,网站备案真实性核验环节花费的时间比较长,为贯彻国务院&quot;放管服&quot;改革要求,工业和信息化部及各省通信管理局自2016年起指导境内接入服务企业开展了APP备案试点工作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12Dy3p.html" rel="bookmark" class="title">php 的  hash&lpar;&amp;amp&semi;amp&semi;&num;39&semi;sha256&amp;amp&semi;amp&semi;&num;39&semi;&comma; &amp;amp&semi;amp&semi;&num;39&semi;zxzxzx&amp;amp&semi;amp&semi;&num;39&semi;&comma;true&rpar;&semi; 对应 java是啥？</a>
					<div>
						问题描述 php 的 hash('sha256', 'zxzxzx',true); 对应 java是啥? php 的 hash('sha256', 'zxzxzx',true); 对应 java是啥? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPka7AM.html" rel="bookmark" class="title">试用main方法发布webservice遇到的问题</a>
					<div>
						问题描述 我初学webservice,按照书上的例子自己敲了一个Demo.如下:package server.soap.bobo.net.bean;import javax.xml.bind.anno ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.040 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
